;          EEPROM.
  ;     EEPROM.
  ;    - 0.     ($FF).
  ;     254,       .
  ;       .
  ;,         .
  ;      ,      .

        in	Temp, SPMCR	; 
	bst	Temp, SPMEN     ;   .
	brts	PC-2

        in      Tmp, MCUCSR	; ,   .

ResetCauseDetermine:
        sbic	EECR, EEWE	; 
	rjmp	PC-1		;  EEPROM.
	
ResetCauseJTAG:
        sbrs    Tmp, JTRF	;   (  ),
        rjmp    ResetCauseWatchdog
        cbr     Tmp, 1<<JTRF	;  .
        ldi	Temp, LOW(eJTAGReset)	;  ,
	out	EEARL, Temp		;  
	ldi	Temp, HIGH(eJTAGReset)	; , 
	out	EEARH, Temp		; .
	rjmp    ResetCauseDetermined    ;     eeprom.

ResetCauseWatchdog:
	sbrs    Tmp, WDRF
        rjmp    ResetCauseBrownOut
        cbr     Tmp, 1<<WDRF
        ldi	Temp, LOW(eWatchdogReset)
	out	EEARL, Temp		
	ldi	Temp, HIGH(eWatchdogReset)
	out	EEARH, Temp		
	rjmp    ResetCauseDetermined

ResetCauseBrownOut:                     ;    .
        ;sbrs    Tmp, BORF
        rjmp    ResetCauseExternal
        ;cbr     Tmp, 1<<BORF
        ;ldi	Temp, LOW(eBrownOutReset)
	;out	EEARL, Temp		
	;ldi	Temp, HIGH(eBrownOutReset)
	;out	EEARH, Temp		
	;rjmp    ResetCauseDetermined
	
ResetCauseExternal:
        sbrs    Tmp, EXTRF
        rjmp    ResetCausePowerOn
        cbr     Tmp, 1<<EXTRF
        ldi	Temp, LOW(eExternalReset)
	out	EEARL, Temp		
	ldi	Temp, HIGH(eExternalReset)
	out	EEARH, Temp		
	rjmp    ResetCauseDetermined
	
ResetCausePowerOn:        	        ;    .
        ;sbrs    Tmp, PORF
        ;rjmp    ResetCauseNext
        ;cbr     Tmp, 1<<PORF
        ;ldi	Temp, LOW(ePowerOnReset)
	;out	EEARL, Temp		
	;ldi	Temp, HIGH(ePowerOnReset)
	;out	EEARH, Temp		
	;rjmp    ResetCauseDetermined

ResetCauseNext:
	rjmp	Exit_ResetCause	;       .

ResetCauseDetermined:
        out     MCUCSR, Tmp	;     ,   .
        sbi	EECR, EERE	; .
	in	Temp, EEDR	;     Temp.
	
	cpi     Temp, $FE       ;       254,
	breq    ResetCauseWritten ;      .
	inc     Temp            ;      255,       0.
	breq	PC-1		;         ( 0)   .
	
	out	EEDR, Temp	;     EEDR.
	sbi	EECR, EEMWE	; 
	sbi	EECR, EEWE	; EEPROM.
	
ResetCauseWritten:
        rjmp    ResetCauseDetermine	;   ,          .

Exit_ResetCause:


